// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('angular_template_type_checker.core');
goog.require('cljs.core');
goog.require('angular_template_type_checker.logging');
goog.require('hickory.zip');
goog.require('angular_template_type_checker.typescript');
goog.require('angular_template_type_checker.templates');
goog.require('cljs.nodejs');
goog.require('instaparse.core');
goog.require('angular_template_type_checker.hickory');
goog.require('cljs.spec');
goog.require('angular_template_type_checker.specs');
goog.require('clojure.string');
goog.require('hickory.core');
DOMParser = cljs.nodejs.require.call(null,"xmldom").DOMParser;
cljs.nodejs.enable_util_print_BANG_.call(null);
angular_template_type_checker.core.glob = cljs.nodejs.require.call(null,"glob");
angular_template_type_checker.core.fs = cljs.nodejs.require.call(null,"fs");
angular_template_type_checker.core.command_line_args = cljs.nodejs.require.call(null,"command-line-args");
angular_template_type_checker.core.getUsage = cljs.nodejs.require.call(null,"command-line-usage");
angular_template_type_checker.core.known_errors_map = new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"no-metadata","no-metadata",803800562),"Could not find metadata"], null);
angular_template_type_checker.core.get_file_contents = (function angular_template_type_checker$core$get_file_contents(glob_pattern){
return (new Promise((function (res,rej){
return angular_template_type_checker.core.glob.call(null,glob_pattern,(function (err,files){
if(cljs.core.truth_(err)){
rej.call(null);
} else {
res.call(null,files);
}

var seq__28997 = cljs.core.seq.call(null,files);
var chunk__28998 = null;
var count__28999 = (0);
var i__29000 = (0);
while(true){
if((i__29000 < count__28999)){
var file = cljs.core._nth.call(null,chunk__28998,i__29000);

var G__29001 = seq__28997;
var G__29002 = chunk__28998;
var G__29003 = count__28999;
var G__29004 = (i__29000 + (1));
seq__28997 = G__29001;
chunk__28998 = G__29002;
count__28999 = G__29003;
i__29000 = G__29004;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__28997);
if(temp__6753__auto__){
var seq__28997__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__28997__$1)){
var c__21520__auto__ = cljs.core.chunk_first.call(null,seq__28997__$1);
var G__29005 = cljs.core.chunk_rest.call(null,seq__28997__$1);
var G__29006 = c__21520__auto__;
var G__29007 = cljs.core.count.call(null,c__21520__auto__);
var G__29008 = (0);
seq__28997 = G__29005;
chunk__28998 = G__29006;
count__28999 = G__29007;
i__29000 = G__29008;
continue;
} else {
var file = cljs.core.first.call(null,seq__28997__$1);

var G__29009 = cljs.core.next.call(null,seq__28997__$1);
var G__29010 = null;
var G__29011 = (0);
var G__29012 = (0);
seq__28997 = G__29009;
chunk__28998 = G__29010;
count__28999 = G__29011;
i__29000 = G__29012;
continue;
}
} else {
return null;
}
}
break;
}
}));
}))).then((function (files){
return Promise.all(cljs.core.map.call(null,(function (p1__28992_SHARP_){
return (new Promise((function (res,rej){
return angular_template_type_checker.core.fs.readFile(p1__28992_SHARP_,"utf8",(function (err,contents){
if(cljs.core.truth_(err)){
return rej.call(null);
} else {
return res.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [contents,p1__28992_SHARP_], null));
}
}));
})));
}),files));
}));
});
angular_template_type_checker.core.check_metadata = (function angular_template_type_checker$core$check_metadata(metadata){

if((metadata == null)){
return new cljs.core.Keyword(null,"no-metadata","no-metadata",803800562);
} else {
var temp__6753__auto__ = cljs.spec.explain_data.call(null,angular_template_type_checker.specs.metadata_spec,metadata);
if(cljs.core.truth_(temp__6753__auto__)){
var spec_error = temp__6753__auto__;
return [cljs.core.str("Error with metadata: "),cljs.core.str(new cljs.core.Keyword("cljs.spec","problems","cljs.spec/problems",608491678).cljs$core$IFn$_invoke$arity$1(spec_error))].join('');
} else {
return null;
}
}
});
angular_template_type_checker.core.verify_template = (function angular_template_type_checker$core$verify_template(var_args){
var args__21837__auto__ = [];
var len__21830__auto___29029 = arguments.length;
var i__21831__auto___29030 = (0);
while(true){
if((i__21831__auto___29030 < len__21830__auto___29029)){
args__21837__auto__.push((arguments[i__21831__auto___29030]));

var G__29031 = (i__21831__auto___29030 + (1));
i__21831__auto___29030 = G__29031;
continue;
} else {
}
break;
}

var argseq__21838__auto__ = ((((2) < args__21837__auto__.length))?(new cljs.core.IndexedSeq(args__21837__auto__.slice((2)),(0),null)):null);
return angular_template_type_checker.core.verify_template.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__21838__auto__);
});

angular_template_type_checker.core.verify_template.cljs$core$IFn$_invoke$arity$variadic = (function (html,filename,p__29018){
var vec__29019 = p__29018;
var ts_config_path = cljs.core.nth.call(null,vec__29019,(0),null);
angular_template_type_checker.logging.info.call(null,"verifying ",filename);

var tags = cljs.core.map.call(null,((function (vec__29019,ts_config_path){
return (function (p1__29013_SHARP_){
return cljs.core.update.call(null,p1__29013_SHARP_,new cljs.core.Keyword(null,"attrs","attrs",-2090668713),cljs.core.comp.call(null,cljs.core.partial.call(null,cljs.core.into,cljs.core.PersistentArrayMap.EMPTY),cljs.core.partial.call(null,cljs.core.map,((function (vec__29019,ts_config_path){
return (function (p__29022){
var vec__29023 = p__29022;
var k = cljs.core.nth.call(null,vec__29023,(0),null);
var v = cljs.core.nth.call(null,vec__29023,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,clojure.string.replace.call(null,v,/\n/,"")], null);
});})(vec__29019,ts_config_path))
)));
});})(vec__29019,ts_config_path))
,cljs.core.filter.call(null,cljs.core.map_QMARK_,angular_template_type_checker.hickory.flatten_hickory.call(null,angular_template_type_checker.hickory.parse_html.call(null,html))));
var metadata = angular_template_type_checker.templates.extract_metadata.call(null,tags);
var var_names = cljs.core.map.call(null,new cljs.core.Keyword(null,"name","name",1843675177),metadata);
var temp__6751__auto__ = angular_template_type_checker.core.check_metadata.call(null,metadata);
if(cljs.core.truth_(temp__6751__auto__)){
var error = temp__6751__auto__;
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [error], null);
} else {
var vec__29026 = cljs.core.juxt.call(null,cljs.core.remove,cljs.core.filter).call(null,instaparse.core.failure_QMARK_,cljs.core.mapcat.call(null,((function (temp__6751__auto__,tags,metadata,var_names,vec__29019,ts_config_path){
return (function (p1__29014_SHARP_){
return angular_template_type_checker.templates.extract_expressions.call(null,p1__29014_SHARP_,var_names);
});})(temp__6751__auto__,tags,metadata,var_names,vec__29019,ts_config_path))
,tags));
var correct_exprs = cljs.core.nth.call(null,vec__29026,(0),null);
var incorrect_exprs = cljs.core.nth.call(null,vec__29026,(1),null);
var typescript = angular_template_type_checker.typescript.build_typescript.call(null,metadata,correct_exprs);
var compiler = angular_template_type_checker.typescript.get_compiler.call(null,filename,(cljs.core.truth_(ts_config_path)?new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"project","project",1124394579),ts_config_path], null):null));
var compilation_error = angular_template_type_checker.typescript.try_compile.call(null,typescript,compiler);
angular_template_type_checker.logging.debug.call(null,"generated typescript:");

angular_template_type_checker.logging.debug.call(null,typescript);

return cljs.core.remove.call(null,cljs.core.nil_QMARK_,cljs.core.conj.call(null,incorrect_exprs,compilation_error));
}
});

angular_template_type_checker.core.verify_template.cljs$lang$maxFixedArity = (2);

angular_template_type_checker.core.verify_template.cljs$lang$applyTo = (function (seq29015){
var G__29016 = cljs.core.first.call(null,seq29015);
var seq29015__$1 = cljs.core.next.call(null,seq29015);
var G__29017 = cljs.core.first.call(null,seq29015__$1);
var seq29015__$2 = cljs.core.next.call(null,seq29015__$1);
return angular_template_type_checker.core.verify_template.cljs$core$IFn$_invoke$arity$variadic(G__29016,G__29017,seq29015__$2);
});

angular_template_type_checker.core.verify_templates = (function angular_template_type_checker$core$verify_templates(var_args){
var args__21837__auto__ = [];
var len__21830__auto___29042 = arguments.length;
var i__21831__auto___29043 = (0);
while(true){
if((i__21831__auto___29043 < len__21830__auto___29042)){
args__21837__auto__.push((arguments[i__21831__auto___29043]));

var G__29044 = (i__21831__auto___29043 + (1));
i__21831__auto___29043 = G__29044;
continue;
} else {
}
break;
}

var argseq__21838__auto__ = ((((1) < args__21837__auto__.length))?(new cljs.core.IndexedSeq(args__21837__auto__.slice((1)),(0),null)):null);
return angular_template_type_checker.core.verify_templates.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__21838__auto__);
});

angular_template_type_checker.core.verify_templates.cljs$core$IFn$_invoke$arity$variadic = (function (glob_pattern,p__29034){
var vec__29035 = p__29034;
var ts_config_path = cljs.core.nth.call(null,vec__29035,(0),null);
return angular_template_type_checker.core.get_file_contents.call(null,glob_pattern).then(((function (vec__29035,ts_config_path){
return (function (data){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.map.call(null,((function (vec__29035,ts_config_path){
return (function (p__29038){
var vec__29039 = p__29038;
var template_html = cljs.core.nth.call(null,vec__29039,(0),null);
var filename = cljs.core.nth.call(null,vec__29039,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [filename,angular_template_type_checker.core.verify_template.call(null,template_html,filename,ts_config_path)], null);
});})(vec__29035,ts_config_path))
,data));
});})(vec__29035,ts_config_path))
);
});

angular_template_type_checker.core.verify_templates.cljs$lang$maxFixedArity = (1);

angular_template_type_checker.core.verify_templates.cljs$lang$applyTo = (function (seq29032){
var G__29033 = cljs.core.first.call(null,seq29032);
var seq29032__$1 = cljs.core.next.call(null,seq29032);
return angular_template_type_checker.core.verify_templates.cljs$core$IFn$_invoke$arity$variadic(G__29033,seq29032__$1);
});

angular_template_type_checker.core.format_error_messages = (function angular_template_type_checker$core$format_error_messages(errors_map,results){
return cljs.core.map.call(null,(function (p__29050){
var vec__29051 = p__29050;
var filename = cljs.core.nth.call(null,vec__29051,(0),null);
var errors = cljs.core.nth.call(null,vec__29051,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [filename,cljs.core.map.call(null,((function (vec__29051,filename,errors){
return (function (p1__29045_SHARP_){
var or__20614__auto__ = cljs.core.get.call(null,errors_map,p1__29045_SHARP_);
if(cljs.core.truth_(or__20614__auto__)){
return or__20614__auto__;
} else {
return p1__29045_SHARP_;
}
});})(vec__29051,filename,errors))
,errors)], null);
}),results);
});
angular_template_type_checker.core.process_results = (function angular_template_type_checker$core$process_results(results){
var errored_files = cljs.core.remove.call(null,(function (p__29068){
var vec__29069 = p__29068;
var _ = cljs.core.nth.call(null,vec__29069,(0),null);
var errors = cljs.core.nth.call(null,vec__29069,(1),null);
return cljs.core.empty_QMARK_.call(null,errors);
}),results);
if(!(cljs.core.empty_QMARK_.call(null,errored_files))){
angular_template_type_checker.logging.info.call(null,"Some templates failed the type check:\r\n");

var seq__29072_29082 = cljs.core.seq.call(null,errored_files);
var chunk__29073_29083 = null;
var count__29074_29084 = (0);
var i__29075_29085 = (0);
while(true){
if((i__29075_29085 < count__29074_29084)){
var vec__29076_29086 = cljs.core._nth.call(null,chunk__29073_29083,i__29075_29085);
var filename_29087 = cljs.core.nth.call(null,vec__29076_29086,(0),null);
var errors_29088 = cljs.core.nth.call(null,vec__29076_29086,(1),null);
angular_template_type_checker.logging.error.call(null,filename_29087);

angular_template_type_checker.logging.error.call(null,"------");

cljs.core.doall.call(null,cljs.core.map.call(null,angular_template_type_checker.logging.error,errors_29088));

angular_template_type_checker.logging.error.call(null,"");

var G__29089 = seq__29072_29082;
var G__29090 = chunk__29073_29083;
var G__29091 = count__29074_29084;
var G__29092 = (i__29075_29085 + (1));
seq__29072_29082 = G__29089;
chunk__29073_29083 = G__29090;
count__29074_29084 = G__29091;
i__29075_29085 = G__29092;
continue;
} else {
var temp__6753__auto___29093 = cljs.core.seq.call(null,seq__29072_29082);
if(temp__6753__auto___29093){
var seq__29072_29094__$1 = temp__6753__auto___29093;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__29072_29094__$1)){
var c__21520__auto___29095 = cljs.core.chunk_first.call(null,seq__29072_29094__$1);
var G__29096 = cljs.core.chunk_rest.call(null,seq__29072_29094__$1);
var G__29097 = c__21520__auto___29095;
var G__29098 = cljs.core.count.call(null,c__21520__auto___29095);
var G__29099 = (0);
seq__29072_29082 = G__29096;
chunk__29073_29083 = G__29097;
count__29074_29084 = G__29098;
i__29075_29085 = G__29099;
continue;
} else {
var vec__29079_29100 = cljs.core.first.call(null,seq__29072_29094__$1);
var filename_29101 = cljs.core.nth.call(null,vec__29079_29100,(0),null);
var errors_29102 = cljs.core.nth.call(null,vec__29079_29100,(1),null);
angular_template_type_checker.logging.error.call(null,filename_29101);

angular_template_type_checker.logging.error.call(null,"------");

cljs.core.doall.call(null,cljs.core.map.call(null,angular_template_type_checker.logging.error,errors_29102));

angular_template_type_checker.logging.error.call(null,"");

var G__29103 = cljs.core.next.call(null,seq__29072_29094__$1);
var G__29104 = null;
var G__29105 = (0);
var G__29106 = (0);
seq__29072_29082 = G__29103;
chunk__29073_29083 = G__29104;
count__29074_29084 = G__29105;
i__29075_29085 = G__29106;
continue;
}
} else {
}
}
break;
}

return false;
} else {
angular_template_type_checker.logging.info.call(null,[cljs.core.str(cljs.core.count.call(null,results)),cljs.core.str(" files verified")].join(''));

return true;
}
});
angular_template_type_checker.core.cli_option_defs = new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),"glob",new cljs.core.Keyword(null,"alias","alias",-2039751630),"g",new cljs.core.Keyword(null,"type","type",1174270348),String,new cljs.core.Keyword(null,"defaultOption","defaultOption",1679025481),true,new cljs.core.Keyword(null,"description","description",-1428560544),"Check templates matching this glob",new cljs.core.Keyword(null,"typeLabel","typeLabel",1121377034),"[underline]{glob}"], null),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),"help",new cljs.core.Keyword(null,"alias","alias",-2039751630),"h",new cljs.core.Keyword(null,"type","type",1174270348),Boolean,new cljs.core.Keyword(null,"description","description",-1428560544),"Shows a help message"], null),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),"ignore-no-metadata",new cljs.core.Keyword(null,"alias","alias",-2039751630),"m",new cljs.core.Keyword(null,"type","type",1174270348),Boolean,new cljs.core.Keyword(null,"description","description",-1428560544),"Ignore files with no metadata"], null),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),"verbose",new cljs.core.Keyword(null,"alias","alias",-2039751630),"v",new cljs.core.Keyword(null,"type","type",1174270348),Boolean,new cljs.core.Keyword(null,"description","description",-1428560544),"Enable verbose logging. Will log generated typescript."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),"ts-config-path",new cljs.core.Keyword(null,"alias","alias",-2039751630),"c",new cljs.core.Keyword(null,"type","type",1174270348),String,new cljs.core.Keyword(null,"description","description",-1428560544),"The relative path to your tsconfig file. Defaults to './tsconfig.json'.",new cljs.core.Keyword(null,"typeLabel","typeLabel",1121377034),"[underline]{path}"], null)], null);
angular_template_type_checker.core._main = (function angular_template_type_checker$core$_main(){
var map__29121 = cljs.core.js__GT_clj.call(null,angular_template_type_checker.core.command_line_args.call(null,cljs.core.clj__GT_js.call(null,angular_template_type_checker.core.cli_option_defs)),new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true);
var map__29121__$1 = ((((!((map__29121 == null)))?((((map__29121.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29121.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29121):map__29121);
var glob = cljs.core.get.call(null,map__29121__$1,new cljs.core.Keyword(null,"glob","glob",-177534284));
var help = cljs.core.get.call(null,map__29121__$1,new cljs.core.Keyword(null,"help","help",-439233446));
var ignore_no_metadata = cljs.core.get.call(null,map__29121__$1,new cljs.core.Keyword(null,"ignore-no-metadata","ignore-no-metadata",1103714588));
var verbose = cljs.core.get.call(null,map__29121__$1,new cljs.core.Keyword(null,"verbose","verbose",1694226060));
var ts_config_path = cljs.core.get.call(null,map__29121__$1,new cljs.core.Keyword(null,"ts-config-path","ts-config-path",-911827320));
if(cljs.core.truth_(help)){
return cljs.core.print.call(null,angular_template_type_checker.core.getUsage.call(null,cljs.core.clj__GT_js.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"header","header",119441134),"ATTyC",new cljs.core.Keyword(null,"content","content",15833224),"A command line tool for checking typed angularjs templates"], null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"header","header",119441134),"Options",new cljs.core.Keyword(null,"optionList","optionList",-1706428365),angular_template_type_checker.core.cli_option_defs], null)], null))));
} else {
return angular_template_type_checker.core.get_file_contents.call(null,glob).then(((function (map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (data){
var _STAR_log_level_STAR_29123 = angular_template_type_checker.logging._STAR_log_level_STAR_;
angular_template_type_checker.logging._STAR_log_level_STAR_ = (cljs.core.truth_(verbose)?new cljs.core.Keyword(null,"debug","debug",-1608172596):new cljs.core.Keyword(null,"info","info",-317069002));

try{var results = angular_template_type_checker.core.process_results.call(null,angular_template_type_checker.core.format_error_messages.call(null,angular_template_type_checker.core.known_errors_map,cljs.core.map.call(null,((function (_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (p__29124){
var vec__29125 = p__29124;
var filename = cljs.core.nth.call(null,vec__29125,(0),null);
var errors = cljs.core.nth.call(null,vec__29125,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [filename,(cljs.core.truth_(ignore_no_metadata)?errors:cljs.core.remove.call(null,((function (vec__29125,filename,errors,_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (p1__29107_SHARP_){
return cljs.core._EQ_.call(null,p1__29107_SHARP_,new cljs.core.Keyword(null,"no-metadata","no-metadata",803800562));
});})(vec__29125,filename,errors,_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
,errors))], null);
});})(_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
,cljs.core.map.call(null,((function (_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (p__29128){
var vec__29129 = p__29128;
var template_html = cljs.core.nth.call(null,vec__29129,(0),null);
var filename = cljs.core.nth.call(null,vec__29129,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [filename,angular_template_type_checker.core.verify_template.call(null,template_html,filename,ts_config_path)], null);
});})(_STAR_log_level_STAR_29123,map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
,data))));
return null;
}finally {angular_template_type_checker.logging._STAR_log_level_STAR_ = _STAR_log_level_STAR_29123;
}});})(map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
).then(((function (map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (p1__29108_SHARP_){
return cljs.nodejs.process.exit((cljs.core.truth_(p1__29108_SHARP_)?(0):(1)));
});})(map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
).catch(((function (map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path){
return (function (p1__29109_SHARP_){
return angular_template_type_checker.logging.error.call(null,p1__29109_SHARP_.message);
});})(map__29121,map__29121__$1,glob,help,ignore_no_metadata,verbose,ts_config_path))
);
}
});
cljs.core._STAR_main_cli_fn_STAR_ = angular_template_type_checker.core._main;
