// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('instaparse.failure');
goog.require('cljs.core');
goog.require('instaparse.print');
/**
 * Takes an index into text, and determines the line and column info
 */
instaparse.failure.index__GT_line_column = (function instaparse$failure$index__GT_line_column(index,text){
var line = (1);
var col = (1);
var counter = (0);
while(true){
if(cljs.core._EQ_.call(null,index,counter)){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"line","line",212345235),line,new cljs.core.Keyword(null,"column","column",2078222095),col], null);
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.get.call(null,text,counter))){
var G__26581 = (line + (1));
var G__26582 = (1);
var G__26583 = (counter + (1));
line = G__26581;
col = G__26582;
counter = G__26583;
continue;
} else {
var G__26584 = line;
var G__26585 = (col + (1));
var G__26586 = (counter + (1));
line = G__26584;
col = G__26585;
counter = G__26586;
continue;

}
}
break;
}
});
instaparse.failure.get_line = (function instaparse$failure$get_line(n,text){
var chars = cljs.core.seq.call(null,clojure.string.replace.call(null,text,"\r\n","\n"));
var n__$1 = n;
while(true){
if(cljs.core.empty_QMARK_.call(null,chars)){
return "";
} else {
if(cljs.core._EQ_.call(null,n__$1,(1))){
return cljs.core.apply.call(null,cljs.core.str,cljs.core.take_while.call(null,cljs.core.complement.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["\n",null], null), null)),chars));
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.first.call(null,chars))){
var G__26587 = cljs.core.next.call(null,chars);
var G__26588 = (n__$1 - (1));
chars = G__26587;
n__$1 = G__26588;
continue;
} else {
var G__26589 = cljs.core.next.call(null,chars);
var G__26590 = n__$1;
chars = G__26589;
n__$1 = G__26590;
continue;

}
}
}
break;
}
});
/**
 * Creates string with caret at nth position, 1-based
 */
instaparse.failure.marker = (function instaparse$failure$marker(n){
if(cljs.core.integer_QMARK_.call(null,n)){
if((n <= (1))){
return "^";
} else {
return cljs.core.apply.call(null,cljs.core.str,cljs.core.concat.call(null,cljs.core.repeat.call(null,(n - (1))," "),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, ["^"], null)));
}
} else {
return null;
}
});
/**
 * Adds text, line, and column info to failure object.
 */
instaparse.failure.augment_failure = (function instaparse$failure$augment_failure(failure,text){
var lc = instaparse.failure.index__GT_line_column.call(null,new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(failure),text);
return cljs.core.merge.call(null,failure,lc,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"text","text",-1790561697),instaparse.failure.get_line.call(null,new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(lc),text)], null));
});
/**
 * Provides special case for printing negative lookahead reasons
 */
instaparse.failure.print_reason = (function instaparse$failure$print_reason(r){
if(cljs.core.truth_(new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r))){
cljs.core.print.call(null,"NOT ");

return cljs.core.print.call(null,new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r));
} else {
if(cljs.core.truth_(new cljs.core.Keyword(null,"char-range","char-range",1443391389).cljs$core$IFn$_invoke$arity$1(r))){
return cljs.core.print.call(null,instaparse.print.char_range__GT_str.call(null,r));
} else {
if((r instanceof RegExp)){
return cljs.core.print.call(null,instaparse.print.regexp__GT_str.call(null,r));
} else {
return cljs.core.pr.call(null,r);

}
}
}
});
/**
 * Takes an augmented failure object and prints the error message
 */
instaparse.failure.pprint_failure = (function instaparse$failure$pprint_failure(p__26591){
var map__26602 = p__26591;
var map__26602__$1 = ((((!((map__26602 == null)))?((((map__26602.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__26602.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26602):map__26602);
var line = cljs.core.get.call(null,map__26602__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column = cljs.core.get.call(null,map__26602__$1,new cljs.core.Keyword(null,"column","column",2078222095));
var text = cljs.core.get.call(null,map__26602__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
var reason = cljs.core.get.call(null,map__26602__$1,new cljs.core.Keyword(null,"reason","reason",-2070751759));
cljs.core.println.call(null,[cljs.core.str("Parse error at line "),cljs.core.str(line),cljs.core.str(", column "),cljs.core.str(column),cljs.core.str(":")].join(''));

cljs.core.println.call(null,text);

cljs.core.println.call(null,instaparse.failure.marker.call(null,column));

var full_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,new cljs.core.Keyword(null,"full","full",436801220),reason)));
var partial_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,cljs.core.complement.call(null,new cljs.core.Keyword(null,"full","full",436801220)),reason)));
var total = (cljs.core.count.call(null,full_reasons) + cljs.core.count.call(null,partial_reasons));
if((total === (0))){
} else {
if(cljs.core._EQ_.call(null,(1),total)){
cljs.core.println.call(null,"Expected:");
} else {
cljs.core.println.call(null,"Expected one of:");

}
}

var seq__26604_26612 = cljs.core.seq.call(null,full_reasons);
var chunk__26605_26613 = null;
var count__26606_26614 = (0);
var i__26607_26615 = (0);
while(true){
if((i__26607_26615 < count__26606_26614)){
var r_26616 = cljs.core._nth.call(null,chunk__26605_26613,i__26607_26615);
instaparse.failure.print_reason.call(null,r_26616);

cljs.core.println.call(null," (followed by end-of-string)");

var G__26617 = seq__26604_26612;
var G__26618 = chunk__26605_26613;
var G__26619 = count__26606_26614;
var G__26620 = (i__26607_26615 + (1));
seq__26604_26612 = G__26617;
chunk__26605_26613 = G__26618;
count__26606_26614 = G__26619;
i__26607_26615 = G__26620;
continue;
} else {
var temp__6753__auto___26621 = cljs.core.seq.call(null,seq__26604_26612);
if(temp__6753__auto___26621){
var seq__26604_26622__$1 = temp__6753__auto___26621;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__26604_26622__$1)){
var c__21520__auto___26623 = cljs.core.chunk_first.call(null,seq__26604_26622__$1);
var G__26624 = cljs.core.chunk_rest.call(null,seq__26604_26622__$1);
var G__26625 = c__21520__auto___26623;
var G__26626 = cljs.core.count.call(null,c__21520__auto___26623);
var G__26627 = (0);
seq__26604_26612 = G__26624;
chunk__26605_26613 = G__26625;
count__26606_26614 = G__26626;
i__26607_26615 = G__26627;
continue;
} else {
var r_26628 = cljs.core.first.call(null,seq__26604_26622__$1);
instaparse.failure.print_reason.call(null,r_26628);

cljs.core.println.call(null," (followed by end-of-string)");

var G__26629 = cljs.core.next.call(null,seq__26604_26622__$1);
var G__26630 = null;
var G__26631 = (0);
var G__26632 = (0);
seq__26604_26612 = G__26629;
chunk__26605_26613 = G__26630;
count__26606_26614 = G__26631;
i__26607_26615 = G__26632;
continue;
}
} else {
}
}
break;
}

var seq__26608 = cljs.core.seq.call(null,partial_reasons);
var chunk__26609 = null;
var count__26610 = (0);
var i__26611 = (0);
while(true){
if((i__26611 < count__26610)){
var r = cljs.core._nth.call(null,chunk__26609,i__26611);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);

var G__26633 = seq__26608;
var G__26634 = chunk__26609;
var G__26635 = count__26610;
var G__26636 = (i__26611 + (1));
seq__26608 = G__26633;
chunk__26609 = G__26634;
count__26610 = G__26635;
i__26611 = G__26636;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__26608);
if(temp__6753__auto__){
var seq__26608__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__26608__$1)){
var c__21520__auto__ = cljs.core.chunk_first.call(null,seq__26608__$1);
var G__26637 = cljs.core.chunk_rest.call(null,seq__26608__$1);
var G__26638 = c__21520__auto__;
var G__26639 = cljs.core.count.call(null,c__21520__auto__);
var G__26640 = (0);
seq__26608 = G__26637;
chunk__26609 = G__26638;
count__26610 = G__26639;
i__26611 = G__26640;
continue;
} else {
var r = cljs.core.first.call(null,seq__26608__$1);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);

var G__26641 = cljs.core.next.call(null,seq__26608__$1);
var G__26642 = null;
var G__26643 = (0);
var G__26644 = (0);
seq__26608 = G__26641;
chunk__26609 = G__26642;
count__26610 = G__26643;
i__26611 = G__26644;
continue;
}
} else {
return null;
}
}
break;
}
});
